lc39+40. 组合总和(回溯算法)

lc39. 组合总和


每日几道leetcode刷刷题!
lc39


题目描述

给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。

candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。

对于给定的输入,保证和为 target 的不同组合数少于 150 个。

输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。


代码

class Solution:
    def combinationSum(self, candidates: List[int], target: int) -> List[List[int]]:
        sum = 0
        path = []
        ans = []
        def backtrack(sum, startIndex):
            if sum > target: #也可以删这段,因为在下面已经判断过一次了
                return
            if sum == target:
                ans.append(path[:])
            for i in range(startIndex, len(candidates)):
                if sum + candidates[i] > target: #剪枝
                    return
                sum += candidates[i]
                path.append(candidates[i])
                backtrack(sum, i)
                path.pop()
                sum -= candidates[i]
        candidates.sort()
        backtrack(0,0)
        return ans

lc40. 组合总和II

传送门

题目描述

给定⼀个数组 candidates 和⼀个⽬标数 target ,找出 candidates 中所有可以使数字和为 target 的组
合。
candidates 中的每个数字在每个组合中只能使⽤⼀次。

(与39不同之处,每个数字在每个组合中只能使⽤⼀次;本题数组candidates的元素是有重复的,⽽39.组合总和是⽆重复元素的数组candidates;)
所以,难点在于如何去重!—即使⽤过的元素不能重复选取。多加一个used来记录已使用过的元素。

代码

class Solution:
    def combinationSum2(self, candidates: List[int], target: int) -> List[List[int]]:
        sum = 0
        path = []
        ans = []
        used = [False] * len(candidates)
        def backtrack(sum, startIndex):
            if sum == target:
                ans.append(path[:])
            for i in range(startIndex, len(candidates)):
                if sum + candidates[i] > target: #剪枝
                    return
                #判断是否已经同一层上调用过了
                if i > 0 and candidates[i] == candidates[i-1] and not used[i - 1]:
                    continue
                used[i] = True
                sum += candidates[i]
                path.append(candidates[i])
                backtrack(sum, i+1)
                path.pop()
                used[i] = False
                sum -= candidates[i]
        candidates.sort()
        backtrack(0,0)
        return ans

在这里插入图片描述
来自公众号【代码随想录】


总结

具体的模板可以参考 回溯算法总结(一)组合问题

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

小杜在学习

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值